﻿using System;
using System.Threading.Tasks;
using Microsoft.Practices.ObjectBuilder2;
using Microsoft.Practices.Unity;
using SingletonExample.Loggers;

namespace SingletonExample
{
    class Program
    {
        static void Main(string[] args)
        {
            //SingleThreadLogger.Instance.Log("Hello World");
            //SingleThreadLogger.Instance.Log("Hello World");
            
            //Parallel.Invoke(() => SingleThreadLogger.Instance.Log("Hello World"),
            //                () => SingleThreadLogger.Instance.Log("Hello World"));

            //Parallel.Invoke(() => ThreadLockConstructorLogger.Instance.Log("Hello World"),
            //                () => ThreadLockConstructorLogger.Instance.Log("Hello World"));

            //Parallel.Invoke(() => ThreadLockReadLogger.Instance.Log("Hello World"),
            //                () => ThreadLockReadLogger.Instance.Log("Hello World"));

            //Parallel.Invoke(() => ThreadLockWriteLogger.Instance.Log("Hello World"),
            //                () => ThreadLockWriteLogger.Instance.Log("Hello World"));

            //Parallel.Invoke(() => LazyLogger.Instance.Log("Hello World"),
            //                () => LazyLogger.Instance.Log("Hello World"));

            var container = new UnityContainer();
            container.RegisterType<ILogger, ConsoleLogger>(
                new ContainerControlledLifetimeManager());
            container.RegisterType<ILogger, ConsoleLogger>();
            container.RegisterType<ILogger, ConsoleLogger>();
            container.RegisterType<IAction<string>, WriteMessageAction>("One");
            container.RegisterType<IAction<string>, WriteMessageAction>("Two");

            var actions = container.ResolveAll<IAction<string>>();
            actions.ForEach(action => action.Do("Hello World"));

            Console.ReadLine();
        }
    }

}
